/*
 * Copyright 2004-2005 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.codehaus.groovy.grails.exceptions;

/**
 * Thrown when a missing property on a Grails data source is missing.
 *
 * @author Steven Devijver
 */
public class DataSourceRequiredPropertyMissingException extends GrailsDataSourceException {

    private static final long serialVersionUID = -1852968042072007818L;

    public DataSourceRequiredPropertyMissingException() {
        super();
    }

    public DataSourceRequiredPropertyMissingException(String message) {
        super(message);
    }

    public DataSourceRequiredPropertyMissingException(String message, Throwable cause) {
        super(message, cause);
    }

    public DataSourceRequiredPropertyMissingException(Throwable cause) {
        super(cause);
    }
}
